/*******************************************************************************
 * FoxStoreUIItemDetail generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxStoreUIItemDetail extends FoxStoreUIBaseWidget within FoxStoreUIExtended
    native(UI);

struct native DetailStatEntry
{
    var init string sStatLabel;
    var init string sStatNumber;
    var init string sStatTooltip;

    structdefaultproperties
    {
        sStatLabel=""
        sStatNumber=""
        sStatTooltip=""
    }
};

var private string WidgetLabel;
var private string PurchaseLabel;
var private string UnablePurchaseLabel;
var transient FoxCustomActor PreviewActor;
var const array< class<FoxStorePreviewNode_Base> > PreviewNodeClasses;
var FoxTypes.EFoxUnlockType PreviewNodeType;
var FoxStorePreviewNode_Base MyPreviewNode;
var FoxPreviewSpawnPoint PreviewSpawnPoint;
var private transient bool bHideDetails;
var delegate<OnPurchaseItem> __OnPurchaseItem__Delegate;
var delegate<OnActivateItem> __OnActivateItem__Delegate;
var delegate<OnDestroyItem> __OnDestroyItem__Delegate;
var delegate<OnRenewItem> __OnRenewItem__Delegate;

delegate OnPurchaseItem(string ItemGuid)
{
    //return;    
}

delegate OnActivateItem(string InstanceId)
{
    //return;    
}

delegate OnDestroyItem(string InstanceId)
{
    //return;    
}

delegate OnRenewItem(string InstanceId)
{
    //return;    
}

function Initialize(int PosX, int PosY)
{
    BindObject(as_addNewStoreDetail(PosX, PosY));
    PreviewSpawnPoint = Outer.Outer.Outer.PCOwner.GetPreviewSpawnPoint();
    //return;    
}

function Cleanup()
{
    __OnPurchaseItem__Delegate = None;
    __OnRenewItem__Delegate = None;
    __OnActivateItem__Delegate = None;
    __OnDestroyItem__Delegate = None;
    // End:0x9A
    if(MyPreviewNode != none)
    {
        MyPreviewNode.Cleanup();
    }
    KillPreviewActor();
    //return;    
}

function KillPreviewActor()
{
    // End:0x32
    if(PreviewActor != none)
    {
        PreviewActor.Destroy();
        PreviewActor = none;
    }
    //return;    
}

function SetWidgetLabel(string Label)
{
    WidgetLabel = Label;
    ApplyWidgetLabel(WidgetLabel);
    //return;    
}

function SetPurchaseLabel(string Label)
{
    PurchaseLabel = Label;
    //return;    
}

function SetUnablePurchaseLabel(string Label)
{
    UnablePurchaseLabel = Label;
    //return;    
}

function ApplyItemDetail(const out StoreMetaData StoreItem, const out InventoryMetaData InventoryItem, optional bool bCanPurchase, optional bool bCanActivate, optional bool bCanRenew, optional bool bCanDestroy)
{
    local int I, Price, nPricingWidgets, CurrencyTypes;
    local float Discount;

    bCanPurchase = false;
    bCanActivate = false;
    bCanRenew = false;
    bCanDestroy = false;
    SetItemDetails(StoreItem.ItemId);
    // End:0x3F4
    if(StoreItem.ItemId != 0)
    {
        as_hideWelcome();
        switch(Outer.Outer.Outer.GetItemUnlockedStateFromStoreItem(StoreItem))
        {
            // End:0x1A0
            case 1:
                CurrencyTypes = class'FoxStoreMetaData'.static.GetNumCurrencyTypes();
                I = 0;
                J0xFD:
                // End:0x19D [Loop If]
                if(I < CurrencyTypes)
                {
                    class'FoxStoreMetaData'.static.GetCheapestPriceForCurrency(StoreItem, byte(I), Price,, Discount);
                    nPricingWidgets += int(AddPricing(Price, byte(I), Discount));
                    ++ I;
                    // [Loop Continue]
                    goto J0xFD;
                }
                // End:0x21C
                break;
            // End:0x1A5
            case 2:
            // End:0x216
            case 3:
                class'FoxStoreMetaData'.static.GetCheapestPriceForCurrency(StoreItem, 1, Price,, Discount);
                nPricingWidgets += int(AddPricing(Price, 1, Discount));
                // End:0x21C
                break;
            // End:0xFFFF
            default:
                // End:0x21C
                break;
        }
        // End:0x235
        if(nPricingWidgets == 0)
        {
            AddEmptyPricing();
        }
        ApplyPurchaseLabel(PurchaseLabel);
        // End:0x2A2
        if(bCanPurchase)
        {
            as_addButton("Purchase", "", "ei_purchaseItem", StoreItem.ItemGuid);
        }
        // End:0x301
        if(bCanActivate)
        {
            as_addButton("ActivateLabel", "", "ei_activateItem", InventoryItem.InstanceId);
        }
        // End:0x35A
        if(bCanRenew)
        {
            as_addButton("RenewLabel", "", "ei_renewItem", InventoryItem.InstanceId);
        }
        // End:0x3B7
        if(bCanDestroy)
        {
            as_addButton("DestroyLabel", "", "ei_destroyItem", InventoryItem.InstanceId);
        }
        as_addButton("ToggleDetailsLabel", "", "ei_toggleDetails");
    }
    //return;    
}

function SetItemDetails(int ItemId)
{
    PreviewNodeType = class'FoxUnlockInfo'.static.GetUnlockTypeFromID(ItemId);
    // End:0xCD
    if((MyPreviewNode == none) || MyPreviewNode.Class != PreviewNodeClasses[PreviewNodeType])
    {
        // End:0xA9
        if(MyPreviewNode != none)
        {
            MyPreviewNode.Cleanup();
        }
        MyPreviewNode = new (self) PreviewNodeClasses[PreviewNodeType];
    }
    MyPreviewNode.Setup(ItemId);
    //return;    
}

function ClearItemDetails()
{
    as_clearStoreDetail();
    ApplyWidgetLabel(WidgetLabel);
    //return;    
}

private final function bool AddPricing(int ItemCost, Engine.OnlineSubsystemTypes.ECurrency CurrencyType, optional float CostMult)
{
    local string CurrentItemCost, OriginalItemCost, Currency, PriceChangePercent;

    CostMult = 1.0;
    // End:0x190
    if(ItemCost > 0)
    {
        Outer.Outer.Outer.GetPricingLabels(ItemCost, CurrentItemCost, CostMult, OriginalItemCost, PriceChangePercent);
        Outer.Outer.Outer.GetCurrencyLabel(CurrencyType, Currency);
        // End:0x172
        if(PriceChangePercent != "")
        {
            as_addDiscountPricing(CurrentItemCost, Currency, OriginalItemCost, PriceChangePercent, Outer.Outer.Outer.DiscountColor);
        }
        // End:0x18E
        else
        {
            as_addPricing(CurrentItemCost, Currency);
        }
        return true;
    }
    return false;
    //return ReturnValue;    
}

private final function AddEmptyPricing()
{
    as_addPricing("", "");
    //return;    
}

function AddItemTag(string TagLabelFirst, string TagLabelSecond, string TagLabelThird, string TagColor)
{
    // End:0x41
    if(TagLabelSecond != "")
    {
        as_addTimedStoreTag(TagLabelFirst, TagLabelSecond, TagLabelThird, TagColor);
    }
    // End:0x5D
    else
    {
        as_addStoreTag(TagLabelFirst, TagColor);
    }
    //return;    
}

private final function ApplyWidgetLabel(string Label)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x9B
    if(BoundObject != none)
    {
        Label = Outer.Outer.LocalizeMenuString(Label);
        BoundObject.SetString("label", Label);
    }
    //return;    
}

private final function ApplyPurchaseLabel(string Label)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0xA3
    if(BoundObject != none)
    {
        Label = Outer.Outer.LocalizeMenuString(Label);
        BoundObject.SetString("purchaseLabel", Label);
    }
    //return;    
}

private final function ei_purchaseItem(string ItemGuid)
{
    OnPurchaseItem(ItemGuid);
    //return;    
}

private final function ei_activateItem(string InstanceId)
{
    OnActivateItem(InstanceId);
    //return;    
}

private final function ei_DestroyItem(string InstanceId)
{
    OnDestroyItem(InstanceId);
    //return;    
}

private final function ei_RenewItem(string InstanceId)
{
    OnRenewItem(InstanceId);
    //return;    
}

private final function ei_toggleDetails()
{
    bHideDetails = !bHideDetails;
    as_hideDetails(bHideDetails);
    //return;    
}

function string as_addNewStoreDetail(int PosX, int PosY)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addNewStoreDetail");
    //return ReturnValue;    
}

function as_addStoreDetailDesc(string Description)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x56
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("addStoreDetailDesc");
    }
    //return;    
}

function as_addStoreDetailStats(const array<StatPanelEntry> Stats)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x57
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("addStoreDetailStats");
    }
    //return;    
}

function as_hideDetails(bool bState)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4F
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("hideDetails");
    }
    //return;    
}

function as_hideWelcome()
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4F
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("hideWelcome");
    }
    //return;    
}

function as_clearStoreDetail()
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x54
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("clearStoreDetail");
    }
    //return;    
}

function as_addStoreTag(string TagLabel, string TagColor)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4F
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("addStoreTag");
    }
    //return;    
}

function as_addTimedStoreTag(string TagLabel1, string TagLabel2, string TagLabel3, string TagColor)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x54
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("addTimedStoreTag");
    }
    //return;    
}

function as_addPricing(string ItemCost, string Currency)
{
    as_addDiscountPricing(ItemCost, Currency, "", "", "");
    //return;    
}

function as_addDiscountPricing(string ItemCost, string Currency, string OriginalCost, string DiscountPercent, string DiscountColor)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4E
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("addPricing");
    }
    //return;    
}

function string as_addButton(string ButtonLabel, string ButtonToolTip, string ExtInterfaceClickFunc, optional string ExtInterfaceArg, optional string transition)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0xE2
    if(BoundObject != none)
    {
        ButtonLabel = Caps(Outer.Outer.LocalizeMenuString(ButtonLabel));
        ButtonToolTip = Outer.Outer.LocalizeMenuString(ButtonToolTip);
        return BoundObject.ActionScriptString("addButton");
    }
    return "";
    //return ReturnValue;    
}

defaultproperties
{
    PreviewNodeClasses(0)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(1)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(2)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(3)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(4)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(5)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(6)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(7)=none
    PreviewNodeClasses(8)=class'FoxStorePreviewNode_Pack'
    PreviewNodeClasses(9)=class'FoxStorePreviewNode_Pack'
    PreviewNodeClasses(10)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(11)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(12)=none
    PreviewNodeClasses(13)=class'FoxStorePreviewNode_Taunts'
    PreviewNodeClasses(14)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(15)=class'FoxStorePreviewNode_Pack'
    PreviewNodeClasses(16)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(17)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(18)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(19)=class'FoxStorePreviewNode_Preset'
    PreviewNodeClasses(20)=class'FoxStorePreviewNode_GearBase'
    PreviewNodeClasses(21)=class'FoxStorePreviewNode_CharacterBase'
    PreviewNodeClasses(22)=class'FoxStorePreviewNode_Depot'
    PreviewNodeClasses(23)=class'FoxStorePreviewNode_CharacterBase'
    PreviewNodeClasses(24)=class'FoxStorePreviewNode_CharacterBase'
    PreviewNodeClasses(25)=class'FoxStorePreviewNode_CharacterBase'
    PreviewNodeClasses(26)=class'FoxStorePreviewNode_Reciever'
    PreviewNodeClasses(27)=class'FoxStorePreviewNode_Mod'
    PreviewNodeClasses(28)=class'FoxStorePreviewNode_Mod'
    PreviewNodeClasses(29)=class'FoxStorePreviewNode_Mod'
    PreviewNodeClasses(30)=class'FoxStorePreviewNode_Magazine'
    PreviewNodeClasses(31)=none
    PreviewNodeClasses(32)=class'FoxStorePreviewNode_Mod'
    PreviewNodeClasses(33)=class'FoxStorePreviewNode_CharacterBase'
    PreviewNodeClasses(34)=none
    PreviewNodeClasses(35)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(36)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(37)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(38)=none
    PreviewNodeClasses(39)=none
    PreviewNodeClasses(40)=none
    PreviewNodeClasses(41)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(42)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(43)=class'FoxStorePreviewNode_Base'
    PreviewNodeClasses(44)=class'FoxStorePreviewNode_Mod'
}